unit test;
interface
uses
	java_lang_String,
	javax_microedition_midlet_MIDlet,
	javax_microedition_lcdui_Display,
	javax_microedition_lcdui_Displayable,
	javax_microedition_lcdui_Canvas,
	javax_microedition_lcdui_Graphics,
	javax_microedition_lcdui_Command,
	javax_microedition_lcdui_CommandListener;
type
	JString = java_lang_String.String;
	main = class(MIDlet, CommandListener)
	public
		procedure startApp; override;
		procedure pauseApp; override;
		procedure destroyApp(flag : boolean); override;
		procedure commandAction(cmd : Command; dsp : Displayable); virtual;
		class procedure quitApp;
	end;

	cnv = class(Canvas)
	public
		procedure paint(g : Graphics); override;
		procedure keyPressed(key : integer); override;
	end;
	
implementation

var
	instance : main;
	dspl : Display;
	fMain : cnv;
	cmdExit : Command;
	mode : integer;
	s : JString;

procedure main.startApp;
begin
	instance := self;
	dspl := Display.getDisplay(self);
	NEW(fMain);
//	NEW(cmdExit, 'Exit', Command.EXIT, 0);
//	fMain.setCommandListener(self);
	fMain.setFullScreenMode(true);
	dspl.setCurrent(fMain);
//	fMain.addCommand(cmdExit);
	mode := 0;
end;

procedure main.pauseApp;
begin
end;

procedure main.destroyApp(flag : boolean);
begin
end;

class procedure main.quitApp;
begin
	instance.destroyApp(false);
	instance.notifyDestroyed;
	instance := nil;
end;

procedure main.commandAction(cmd : Command; dsp : Displayable);
begin
	if cmd = cmdExit then begin
		quitApp;
	end;
end;

procedure cnv.paint(g : Graphics);
begin
	g.setColor(0, 0, 0);
	g.fillRect(0, 0, self.getWidth, self.getHeight);
	if mode = 1 then begin
		g.setColor(0, 255, 0);
		g.drawRect(10, 10, 50, 50);
	end else if mode = 2 then begin
		g.setColor(0, 0, 255);
		g.drawArc(50, 50, 100, 100, 0, 360);
	end;
	g.setColor(255, 255, 255);
	g.drawString(s, 30, 30, 20);
end;

procedure cnv.keyPressed(key : integer);
begin
	if key = Canvas.KEY_POUND then
		instance.quitApp
	else if key = Canvas.KEY_NUM1 then
		mode := 1
	else if key = Canvas.KEY_NUM2 then
		mode := 2;
		s := JString.valueOf(mode);
	fMain.repaint;
end;
	
end.
